<?php
 


class Limex_Advr_Block_Adminhtml_Catalog_Attributeset 
    extends Limex_Advr_Block_Adminhtml_Catalog_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales by Attribute Set'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('category')
            ->setXAxisField('product_attribute_set_id')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_item_row_total')
            ->setDefaultDir('desc')
            ->setDefaultLimit(1000)
            ->setPagerVisibility(false)
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $attribute = $this->getFilterData()->getGroupByAttribute();

        if (!$attribute) {
            $attribute = 'status'; 
        }

        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('catalog/product')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('product_attribute_set_id')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'product_attribute_set_id' => array(
                'header'          => 'Attribute Set',
                'type'            => 'text',
                'totals_label'    => 'Total',
                'filter'          => false,
                'frame_callback'  => array($this, 'frameCallbackAttributeSet'),
                'chart'           => true,
                'export_callback' => array($this, 'frameCallbackAttributeSet'),
            ),
        );

        $columns += $this->getBaseProductColumns(true);

        $columns['actions'] = array(
            'header'       => 'Actions',
            'actions'      => array(
                array(
                    'caption'  => Mage::helper('advr')->__('Detail'),
                    'callback' => array($this, 'detailUrlCallback')
                ),
            ),
        );

        return $columns;
    }

    public function frameCallbackAttributeSet($value, $row, $column)
    {
        return Mage::getModel('eav/entity_attribute_set')->load($value)->getAttributeSetName();
    }

     public function detailUrlCallback($row)
    {
        $url = $this->getUrl('advradmin/adminhtml_catalog/attributesetDetail', array(
                'attribute_set_id' => $row->getProductAttributeSetId(),

            )
        );

        return $url;
    }
}