<?php
 


class Limex_Advr_Block_Adminhtml_Catalog_Attributeset_Detail
    extends Limex_Advr_Block_Adminhtml_Catalog_Abstract
{

    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(
            Mage::helper('advr')->__('Sales Report for attribute set "%s"',
                Mage::registry('current_attribute_set')->getAttributeSetName()
            )
        );

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('datetime')
            ->setXAxisField('period')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('sum_item_row_total')
            ->setDefaultDir('desc')
            ;

        return $this;
    }

    protected function _prepareToolbar()
    {
        $this->_initToolbar()
            ->setRangesVisibility(false)
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('catalog/product')
            ->setFilterData($this->getFilterData())
            ->selectColumns(array_merge(
                array('product_attribute_set_id'),
                $this->getVisibleColumns())
            )
            ->groupByColumn('period')
            ->groupByColumn('product_attribute_set_id')
            ->addFieldToFilter('product_attribute_set_id', 
                Mage::registry('current_attribute_set')->getId())
            ;

        // echo Limex_SqlFormatter::format($collection->getSelect());

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'period' => array(
                'header'                => 'Period',
                'type'                  => 'text',
                'frame_callback'        => array(Mage::helper('advr/callback'), 'period'),
                'totals_label'          => 'Total',
                'filter_totals_label'   => 'Subtotal',
                'grouped'               => true,
                'filter'                => false,
            ),
        );

        $columns += $this->getBaseProductColumns(true);

        return $columns;
    }
}