<?php
 


class Limex_Advr_Block_Adminhtml_Order_Coupon extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales By Coupon'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('column');

        $this->_initChart()
            ->setXAxisType('category')
            ->setXAxisField('coupon_code')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('hour_of_day')
            ->setDefaultDir('asc')
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('sales/order')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('coupon_code')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'coupon_code' => array(
                'header'         => 'Coupon Code',
                'type'           => 'text',
                'totals_label'   => 'Total',
                'chart'          => true,
            ),
        );

        $columns += $this->getOrderTableColumns(true);

        return $columns;
    }
}